Bug 239466 - Warn of disabling RT if only TSC is present
Warn of disabling RT if only TSC is present
Product: Red Hat Enterprise MRG
Classification: Red Hat
Component: realtime-kernel (Show other bugs)
All Linux
low Severity low
: ---
: ---
Assigned To: Thomas Gleixner
Depends On:
  Show dependency treegraph
Reported: 2007-05-08 12:48 EDT by Steven Rostedt
Modified: 2009-02-25 16:19 EST (History)
4 users (show)

See Also:
Fixed In Version:
Doc Type: Bug Fix
Doc Text:
Story Points: ---
Clone Of:
Last Closed: 2009-02-25 16:19:12 EST
Type: ---
Regression: ---
Mount Type: ---
Documentation: ---
Verified Versions:
Category: ---
oVirt Team: ---
RHEL 7.3 requirements from Atomic Host:
Cloudforms Team: ---

Attachments (Terms of Use)

  None (edit)
Description Steven Rostedt 2007-05-08 12:48:53 EDT
Description of problem:

Talking with tglx on IRC I found that the HR timers is disabled if only
a TSC is present.  This is because the TSC can not be trusted without
having a backup clock to check it against.   So if someone configures
the kernel correctly, but only enables the TSC, they will be confused
to why the HR timers is not enabled.

Version-Release number of selected component (if applicable):

How reproducible:

Steps to Reproduce:
1. Configure only the TSC clock
2. boot kernel
Actual results:

No idea why the HR timers is disabled.

Expected results:

Notify user via bootup message that the HR timers
is disabled since only the TSC is enabled. Need a backup
clock source to enable the HR timers.

Additional info:

This should probably be documented somewhere, since I didn't know
about this until someone complained, and tglx said that the TSC needs
a backup clock to enable HR timers.
Comment 1 Tim Burke 2007-05-14 22:37:10 EDT
Asigning this one to Bhavana, as it likely relates to bug #230638.  Minimally
this warrants description in our release notes for RHEL-RT.
Comment 2 john stultz 2007-05-18 14:55:09 EDT
Summary should probably be "Warn of disabling *HRT*", as other aspects of the
-rt patch still should function.
Comment 3 Bhavna Sarathy 2007-07-25 13:59:02 EDT
tscsync only enables features in the powernow-k8 driver and does nothing to the
Linux timer code.  Disable cpufreq and check if using TSC as the time source has
the same effect of diabling *HRT*.   What you have described might be an
artifact of the TSC and not Power Now! + tscsync.
Comment 4 Tim Burke 2007-10-02 15:39:04 EDT
I asked tglx for suggestions on this bug, his reply:

1) we need to add some printk warning, why TSC is not used. We have a 
mainline patch for this

2) add documentation about it:

Requirements for -HRT:
- Stable clock source (acpi_pm_timer or hpet)
- TSC is not trusted due to:
  - unsynchronized TSC on SMP
  - TSC stops in certain power modes (that's probably irrelevant for
  servers, but we have already seen boxen where the BIOS switches into a
  deeper power safe idle mode behind the kernels back)
Comment 5 Tim Burke 2007-10-02 15:39:42 EDT
On the above points, I asked tglx for some more specific info. ie, the specific
patch and more details for documentation.
Comment 6 Clark Williams 2008-04-23 17:11:27 EDT
Where are we on this bug?

Have we actually added printk's to indicate that HRT has been disabled?


Comment 7 Bhavna Sarathy 2008-04-24 16:58:07 EDT
As I mentioned in comment #3 a while back this bug is not related to tscsync or
Power Now!.  Please reassign to a timer expert.  Thanks,
Comment 8 Clark Williams 2008-04-24 17:05:43 EDT

reassigning to Thomas

Comment 9 Clark Williams 2008-09-15 23:28:31 EDT
Is this still the case (that HRT is disabled if TSC is only clock source)?

Note You need to log in before you can comment on or make changes to this bug.